##JWW日影へ変換のためのスクリプトv1.0.0 by TAK2HATA(kurohoppie@gmail.com)
##免責事項：このスクリプトを使用して発生した如何なる損害もスクリプト著作者は責任を負わないものとします。このことをご理解したうえでご使用ください。
##著作権は作者であるTAK2HATAにあります。ご自由に使用して構いません。
##改変などは自由に行って構いませんが、モジュールを分ける、デフォルト値の保存場所を変える、などして他のスクリプトとの干渉を避けてください。
##販売物にこのスクリプトを含めることは禁止します。しかしこのコードの一部を参考にして作成されたスクリプトについては特に言及するつもりはありません。
##万が一このスクリプトを含めたまま販売を行った場合、このスクリプトにまったく同じ機能を実装して無料で公開したいと思います。
##modified1:2013/09/08 高速化、日差し錐線の算定
##modified2:2013/09/09 高速化
##modified3:2013/09/10 ライン上の日影時間チャートグラフを作れるようにした。
##modified4:2013/09/15 高速化など。
##modified5:2013/09/16 バグフィックス、真北の取得

#require 't2h_export2jw_shadow/win32ole.so'
module TAK2HATA
module T2H_Export2JW_Shadow
module T2H_SUNLINES
	def read_north(chk=false)
		model = Sketchup.active_model
		ang = []
		model.active_entities.find_all{|e| e.kind_of? Sketchup::ComponentInstance and e.visible? and e.layer.visible? and e.definition.behavior.always_face_camera? == false }.each{|cins|
			if cins.definition.name[0,13] == "JWT_NorthMark"
				ctr = cins.transformation
				vec=Geom::Vector3d.new(0,1,0).transform( ctr )
				ang.push ( Math.atan2(vec.y,vec.x).radians - 90.0 )
			end
		}
		if chk == false
		if ang != []
			UI.messagebox "真北方向が#{ang[0].to_s}と読み取れました。"
			model.set_attribute( "T2H_EXPORT2JW_SHADOWS" , "真北" , ang[0].to_s )
		else
			UI.messagebox "真北方向が読み取れませんでした。"
		end
		end
	end
	def input_suninfo()
		model = Sketchup.active_model
		read_north(true)
		skptime = model.shadow_info["ShadowTime"]
		yy=model.get_attribute( "T2H_EXPORT2JW_SHADOWS" , "年" , Time.now.year )
		mmdd=model.get_attribute( "T2H_EXPORT2JW_SHADOWS" , "月日" , "12/22" )
		nang = model.get_attribute( "T2H_EXPORT2JW_SHADOWS" , "真北" , "0.0" )
		nlat=model.get_attribute( "T2H_EXPORT2JW_SHADOWS" , "緯度" , "36.0" )
		st=model.get_attribute( "T2H_EXPORT2JW_SHADOWS" , "開始時刻" , "8.0" )
		en=model.get_attribute( "T2H_EXPORT2JW_SHADOWS" , "終了時刻" , "16.0" )
		sht=model.get_attribute( "T2H_EXPORT2JW_SHADOWS" , "測定面高さ" , "#{4000.mm}" )
		limit=model.get_attribute( "T2H_EXPORT2JW_SHADOWS" , "日影時間制限" , "3" )
		yl=["2000"]
		(2000..2020).each{|i| yl.push i.to_s}
		yearlist = yl.join("|")
		daylist = ["12/22","6/21","3/20","#{skptime.month}/#{skptime.day}"].join("|")
		prompts = ["計算時年" , "計算時月日","真北方向", "緯度", "開始時刻" ,"終了時刻","測定面高さ","日影時間制限" ]
		defaults = [yy.to_s,mmdd.to_s,nang.to_s,nlat.to_s,st.to_s,en.to_s,sht.to_s,limit.to_s]
		list = [yearlist, daylist]
		res = UI.inputbox prompts, defaults, list, "日差し錐線の設定"
		if not res or res ==[]
			return
		end
		yy = res[0]
		mmdd = res[1]
		mm = mmdd.split("/")[0]
		dd = mmdd.split("/")[1]
		nang = res[2].to_f
		nlat = res[3].to_f
		st = res[4].to_i
		en = res[5].to_i
		sht = res[6].to_l
		limit = res[7].to_f
		model.set_attribute( "T2H_EXPORT2JW_SHADOWS" , "年" , yy )
		model.set_attribute( "T2H_EXPORT2JW_SHADOWS" , "月日" , mmdd )
		model.set_attribute( "T2H_EXPORT2JW_SHADOWS" , "真北" , nang.to_s )
		model.set_attribute( "T2H_EXPORT2JW_SHADOWS" , "緯度" , nlat.to_s )
		model.set_attribute( "T2H_EXPORT2JW_SHADOWS" , "開始時刻" , st.to_s )
		model.set_attribute( "T2H_EXPORT2JW_SHADOWS" , "終了時刻" , en.to_s )
		model.set_attribute( "T2H_EXPORT2JW_SHADOWS" , "測定面高さ" , sht.to_s )
		model.set_attribute( "T2H_EXPORT2JW_SHADOWS" , "日影時間制限" , limit.to_s )

		nlon= 140#経度は日影図に関係しない（真太陽時で行うので）
		nlat= nlat/180*Math::PI
		nlon= (nlon-135)/180*Math::PI
		return yy,mm,dd,nang,nlat,st,en,nlon,sht,limit
	end
	def create_hour_min_list(st,en,mdiv=2)
		hmlist = []
		(st..(en-1)).each{|h|
		mdiv.times{|i|
			m = ( 60 / mdiv * i ).to_i
			#[0,30].each{|m|
			hmlist.push [h,m]
			#}
			}
		}
		hmlist.push [16,0]
		
		return hmlist
	end
	def calc_basesun( yy,mm,dd )
		#dn元旦からの日数
		dn = Time.local(yy,mm,dd,12,0).strftime("%j").to_f
		sit=2*Math::PI*(dn-1)/365
		#del太陽赤緯
		del=0.006918-0.399912*Math.cos(sit)+0.070257*Math.sin(sit)-0.006758*Math.cos(2.0*sit)+0.000907*Math.sin(2.0*sit)-0.002697*Math.cos(3.0*sit)+0.001480*Math.sin(3.0*sit)
		#rr地心太陽距離
		#rr=1.000110+0.034221*Math.cos(sit)+0.001280*Math.sin(sit)+0.000719*Math.cos(2.0*sit)+0.000077*Math.sin(2.0*sit)
		#eq均時差
		#eq=0.000075+0.001868*Math.cos(sit)-0.032077*Math.sin(sit)-0.014615*Math.cos(2.0*sit)-0.040849*Math.sin(2.0*sit)
		return del
	end
	def calc_sundir( h , m , nlat , del , nrtr )
		#tang太陽の時角
		tang=( h.to_f + ( m.to_f / 60.0 ) - 12.0 ) / 12.0 * Math::PI# + nlon# + eq
		
		#sina太陽高度 SIN
		sina= Math.sin(nlat) * Math.sin(del)+Math.cos(nlat)*Math.cos(del)*Math.cos(tang)
		#flux=1367*rr2*sina#大気外全天日射量
		aang = Math.asin(sina)
		#sundir太陽方位
		bang = Math.atan2(Math.cos(nlat)*Math.cos(del)*Math.sin(tang) , Math.sin(nlat)*sina-Math.sin(del))

		sundir = Geom::Vector3d.new( 0 , 1 , 0)
		sundir.transform!( Geom::Transformation.rotation( [0,0,0] , Geom::Vector3d.new(1,0,0) , aang ) )
		sundir.transform!( Geom::Transformation.rotation( [0,0,0] , Geom::Vector3d.new(0,0,1) , bang ) )
		sundir.transform!( nrtr )

		return sundir
	end
	def create_sunlinesdf(yy,mm,dd,nlat,nang)
		model = Sketchup.active_model
		dfs = model.definitions
		dfname = "JWT_SunRays#{yy}_#{mm}_#{dd}_lat#{nlat}_north#{nang}"
		ndf = dfs[dfname]
		if not ndf
			ndf = dfs.add(dfname)
			ndf.entities.add_cpoint( [0,0,0] )
		else
			ndf.entities.clear!
			ndf.entities.add_cpoint( [0,0,0] )
		end
		return ndf
	end
	def create_hizashilines()
		#近似算定の太陽位置による日差し円錐線
		#中川清隆研究室様のホームページ(http://es.ris.ac.jp/~nakagawa/met_cal/solar.html)を使わせていただき任意時刻任意緯度の太陽高度と方位を算出しています。
		model = Sketchup.active_model
		yy,mm,dd,nang,nlat,st,en,nlon,sht,limit = input_suninfo()
		#p yy,mm,dd,nang,nlat,st,en,nlon,sht
		model.start_operation "日差し錐線の描画",true
		ndf = create_sunlinesdf(yy,mm,dd,nlat,nang)
		l = model.bounds.diagonal
		l = 10000 if l == 0
		del = calc_basesun( yy,mm,dd )
		hmlist = create_hour_min_list(st,en)
		nrtr = Geom::Transformation.rotation( [0,0,0] , Geom::Vector3d.new(0,0,1) , ( 180 + nang ).degrees )
		pts = []
		hmlist.each{|h,m|
			sundir = calc_sundir( h , m , nlat , del , nrtr )
			#p sundir
			sundir.length = l
			#p sundir
			pts.push Geom::Point3d.new( sundir.x , sundir.y , sundir.z + sht )
			#spos = [ sundir.x , sundir.y , sundir.z ]
			#ndf.entities.add_line( [0,0,0] ,spos )
		}

		( pts.size - 1 ).times{|i|
			pts2 = []
			pts2.push pts[i]
			pts2.push pts[i+1]
			pts2.push [0,0,sht]
			ndf.entities.add_face pts2
		}
		model.commit_operation
		model.place_component ndf, false
	end
=begin
	def create_hizashilines2()
		#スケッチアップの太陽位置による日差し円錐線
		model = Sketchup.active_model
		yy,mm,dd,nang,nlat,st,en,nlon,sht,limit = input_suninfo()
		model.start_operation "日差し錐線の描画2",true
		ndf = create_sunlinesdf(yy,mm,dd,nlat,nang)
		l = model.bounds.diagonal
		hmlist = create_hour_min_list(st,en)
		nrtr = Geom::Transformation.rotation( [0,0,0] , Geom::Vector3d.new(0,0,1) , ( 180 + nang ).degrees )
		#現在のShadowInfoの確保
		cnang = model.shadow_info["NorthAngle"]
		cntime =model.shadow_info["ShadowTime"]
		clat = model.shadow_info["Latitude"]
		#ShadowInfoの書き換え
		model.shadow_info["NorthAngle"] = -nang.to_f
		model.shadow_info["Latitude"] = nlat.radians

		hmlist.each{|h,m|
			model.shadow_info["ShadowTime"] = Time.gm(yy,mm,dd,h,m)
			svec = model.shadow_info["SunDirection"]
			svec.length = l
			spos = [ svec.x , svec.y ,( svec.z + sht )]
			ndf.entities.add_line( [0,0,sht] ,spos )
		}
		#ShadowInfoの復元
		model.shadow_info["NorthAngle"] = cnang
		model.shadow_info["ShadowTime"] = cntime
		model.shadow_info["Latitude"] = clat
		model.commit_operation
		model.place_component ndf, false
	end
=end
end#module
class T2H_Click_Edge_Tool
	include TAK2HATA::T2H_Export2JW_Shadow::T2H_SUNLINES
	def initialize
		@ip = Sketchup::InputPoint.new
		@vpts = []
		reset
	end

	def reset
		@ip.clear
		Sketchup::set_status_text "Pick entity"
	end
	def deactivate(view)
		#p "deactive"
		view.invalidate if @drawn == false
	end
	def onCancel(reason, view)
		reset
	end
	def activate
		self.reset
	end

	def draw(view)
		if @vpts.size > 1
			paintcolor = Sketchup::Color.new(255, 0, 0)
			paintcolor.alpha = 128
			view.line_width=5
			view.drawing_color = paintcolor
			view.draw_polyline(@vpts)
		end
	end
	def onMouseMove(flags, x, y, view)
		@ip.pick(view,x,y)
		tr = @ip.transformation
		ed = @ip.edge
		if ed != nil
			if ed.curve
				#p "curve"
				@vpts = ed.curve.vertices.map{|vt| vt.position.transform( tr ) }
				view.invalidate
			else
				@vpts = ed.vertices.map{|vt| vt.position.transform( tr ) }
				view.invalidate
			end
		end
	end
	def getvts(ed,tr)
		if ed.curve
			vpts = []
			ed.curve.vertices{|vt|
				vpts.push vt.position.transform( tr )
			}
			return vpts
		else
			vpts = []
			ed.vertices{|vt|
				vpts.push vt.position.transform( tr )
			}
			return vpts
		end
	end
	def onLButtonDown(flags, x, y, view)
		if @vpts.size > 1
			done_select_edge(@vpts)
		end
		#@vpts = []
		#@ip.pick(view,x,y)
		#tr = @ip.transformation
		#ed = @ip.edge
		#if ed != nil
			#@vpts = getvts(ed,tr)
		#	view.invalidate
		#	done_select_edge(@vpts)
		#end
	end
	def done_select_edge(vts)
		#線上におけるチャートの作成１時間を１ｍとして鉛直に描画
		model = Sketchup.active_model
		yy,mm,dd,nang,nlat,st,en,nlon,sht,limit = input_suninfo()
		model.start_operation "日差し錐線の描画",true
		ndf = create_sunlinesdf(yy,mm,dd,nlat,nang)
		
		del = calc_basesun( yy,mm,dd )
		mdiv = 60
		hmlist = create_hour_min_list(st,en,mdiv)#1分刻み
		nrtr = Geom::Transformation.rotation( [0,0,0] , Geom::Vector3d.new(0,0,1) , ( 180 + nang ).degrees )
		chartlist = []
		hgtime = 0.0
		lwtime = 10.0
		(vts.size).times{|t|
			#次の点までの距離を求め、１メートル以上の場合は分割を行う
			
			pts = []
			if vts.size != ( t + 1 )
				d = vts[t].distance( vts[t+1] )
				if d > 1.m
					div = d.to_m.to_i + 1
					div.times{|i|
						weight1 = i.to_f / div.to_f
						weight2 = 1.0 - weight1
						pts.push Geom::Point3d.linear_combination( weight2, vts[t] , weight1, vts[t+1] )
					}
				else
					pts.push vts[t]
				end
			else
				pts.push vts[t]
			end
			sundirlist = []
			hmlist.each{|h,m|
				sundirlist.push calc_sundir( h , m , nlat , del , nrtr )
			}
			i = 0
			pts.each{|pt|
				i += 1
				Sketchup.set_status_text "計算中:#{i}/#{pts.size}", SB_PROMPT#端点#{t}/#{vts.size-1}分割数#{i}/#{div}"
				rcnt = 0#光線のヒット回数
				pt.z = pt.z + sht#shtは測定高さ
				#hmlist.each{|h,m|
					#sundir = calc_sundir( h , m , nlat , del , nrtr )
				#}
				sundirlist.each{|sundir|
					ray = [ pt , sundir ]
					pt2 , nests = model.raytest( ray , true )
					if pt2
						rcnt += 1
					end
				}

				stime = rcnt.to_f / mdiv.to_f #影の時間
				hgtime = stime if stime > hgtime
				lwtime = stime if stime < lwtime
				chartlist.push [ pt , stime ]
			}
			
		}
		chartmodel = model.active_entities.add_group
		chartmodel.name = "ChartModel"
		chpts = []#チャートの折れ線
		nlpts = []#基準の折れ線
		chartlist.each{|pt,stime|
			Sketchup.set_status_text "描画中", SB_PROMPT
			nlpts.push pt.clone
			t_to_l = 1.m #１時間あたりの高さ
			if stime.to_f > limit.to_f
				pt.z = pt.z+ ( stime.to_f - limit.to_f ) * t_to_l.to_f
				if stime == hgtime
					chartmodel.entities.add_text(  sprintf("%#.02g", stime)+"時間",pt,Geom::Vector3d.new(0,0,1.m) )
				end
			end

			chpts.push pt.clone
		}
		chartmodel.entities.add_edges nlpts
		chartmodel.entities.add_edges chpts
		model.commit_operation
	end
end
class T2H_Exp2JWCLASS
	include TAK2HATA::T2H_Export2JW_Shadow::T2H_SUNLINES
	def get_nonverticalfaces_only( ents , loop_list , edlist ,tr ,smallest_area = 0)
		zvec = Geom::Vector3d.new(0,0,1)
		edgelist = Hash.new
		ents.find_all{|e| e.kind_of? Sketchup::Face}.each{|e|
			if e.visible? and e.layer.visible? and e.area >= smallest_area.m.m
				if e.normal.transform( tr ).perpendicular?(zvec) != true
					edgelist[ e ] = true
					pts = e.outer_loop.vertices.map{|vt| vt.position.transform( tr ) }
					#zpts = pts.find_all{|pt| pt.z <= 0 }
					#if zpts.size != pts.size#全ての頂点のＺが0以下の場合は無視する
						i = 0
						pts2 = []
						pts1 = e.outer_loop.vertices.map{|vt| vt.position.transform( tr ) }
						pts1.each{|pt|
							if i == 0
								pts2[i] = pt
								i += 1
							elsif pts2[i] == nil
								pts2[i] = pt
							else
								vec1 = pts2[i-1].vector_to( pts2[i] )
								vec2 = pts2[i-1].vector_to( pt )
								if vec1.samedirection?(vec2)
									pts2[i] = pt
								else
									i += 1
									pts2[i] = pt
								end
							end
						}
						if pts2.last != pts1.last
							pts2.push pts1.last
						end
						loop_list.push [ pts2 ]
						Sketchup.status_text = "get faces:#{loop_list.size}"
					#end
				end
			end

		}
		ents.find_all{|e| e.kind_of? Sketchup::Edge and e.faces.size == 0}.each{|e|
			if e.visible? and e.layer.visible?
				if edgelist[ e ] == nil
					if not e.line[1].parallel?( Geom::Vector3d.new(0,0,1) )
						pts2 = e.vertices.map{|vt| vt.position.transform( tr ) }
						pts2.each{|pt| pt.z = 0 }
						edlist.push pts2
					end
				end
			end
		}
	end
	def get_nonverticalfaces( ents , loop_list , edlist ,tr ,smallest_area = 0.to_m.to_m )
		get_nonverticalfaces_only( ents , loop_list , edlist ,tr ,smallest_area)
		ents.find_all{|e| e.kind_of? Sketchup::Group and e.visible? and e.layer.visible? }.each{|gr|
			gtr = gr.transformation
			tr2 = tr * gtr
			get_nonverticalfaces( gr.entities , loop_list , edlist , tr2 ,smallest_area)
		}
		ents.find_all{|e| e.kind_of? Sketchup::ComponentInstance and e.visible? and e.layer.visible? and e.definition.behavior.always_face_camera? == false }.each{|cins|
			if cins.definition.name[0,16] == "JWT_HIKAGE_MODEL"
			elsif cins.definition.name[0,13] == "JWT_NorthMark"
				ctr = cins.transformation
				tr2 = tr * ctr
				npts = []
				npts[0] = [0,-5000.mm,0]
				npts[1] = [0,5000.mm,0]
				@northpt = npts.map{|pt| pt.transform( tr2 )}
			elsif cins.definition.name[0,6]!="[TEXT]"
				ctr = cins.transformation
				tr2 = tr * ctr
				get_nonverticalfaces( cins.definition.entities , loop_list , edlist , tr2 ,smallest_area)
			end
		}
	end
	def creat_hikagemodel
		#hikagegrpを作ってそこに全ての面とエッジを描画する
		model = Sketchup.active_model
		ents = model.active_entities

		loop_list = []
		edlist = []
		get_nonverticalfaces( ents , loop_list , edlist , Geom::Transformation.new( [0,0,0] ) )
		plycount = 0
		loop_list.each{|lp|
			plycount += lp.size * 2
		}
		#chkint = true
		if plycount > 6000
			#res = UI.messagebox( "描画頂点数が#{plycount}あり、\n計算に膨大な時間が掛かります。\n継続しますか？" , MB_OKCANCEL )
			res = UI.messagebox( "描画頂点数が#{plycount}あり、\n計算に膨大な時間が掛かります。\n極小な面を除外し継続しますか？" , MB_OKCANCEL )

			if res == 2
				Sketchup.status_text = "中止しました"
				return nil
			else
				loop_list = []
				edlist = []
				smallest_area = 0.01
				get_nonverticalfaces( ents , loop_list , edlist , Geom::Transformation.new( [0,0,0] ) , smallest_area )
			end
		end
		Sketchup.set_status_text "面の抽出・描画:#{loop_list.size}", SB_PROMPT
		model.start_operation("日影用モデル整理",true)
		hgrpcomp = model.definitions["JWT_HIKAGE_MODEL"]
		if not hgrpcomp
			hgrpcomp = model.definitions.add("JWT_HIKAGE_MODEL")
		else
			hgrpcomp.entities.clear!
		end
		hgrp = hgrpcomp.entities.add_group

		hents = hgrp.entities
		eyevec = Geom::Vector3d.new(0,0,-1)
		err = 0
		pmesh = Geom::PolygonMesh.new( loop_list.size )

		#pmeshes = []
		cnt = 0
		loop_list.each{|pts,nr|
			cnt += 1
			if ( cnt % 10 ) == 0
				Sketchup.set_status_text "面の抽出・描画:#{cnt} / #{loop_list.size}", SB_PROMPT
			end
			pmesh.add_polygon pts
			#垂直面の発生は一度整理してから
		}
		hents.fill_from_mesh( pmesh , true , 0 )

		p "エラー数:#{err}"

		Sketchup.status_text = "見え隠れの処理"
		cleanup(ents,hgrp,eyevec)

		#面の整理後に2Ｄ図面情報を抽出
		#今回は日影の想定のため面情報優先
		#見えがかりの描画の際には処理を変えることになる
		Sketchup.status_text = "エッジの抽出"
		cnt = 0
		#return if @debug == true
		edlist.each{|pts|
			cnt += 1
			if ( cnt % 10 ) == 0
				Sketchup.set_status_text "エッジの抽出:#{cnt} / #{edlist.size}", SB_PROMPT
			end
			hents.add_edges( pts )
		}
		vgrp = create_verticalfaces(hgrpcomp.entities,hgrp)
		hgrp.explode
		Sketchup.status_text = "日影用モデル整理完了"
		model.commit_operation
		return hgrpcomp
	end
#	model = Sketchup.active_model;ents = model.active_entities;sels = model.selection;sels[0].entities.intersect_with( false , sels[0].transformation , sels[1] , sels[1].transformation , false , sels[1] );
	#インターセクションはentitie2の方にしか交線を発生しないみたい
	def get_z0_count(vfc)
		zlist = vfc.vertices.find_all{|vt| vt.position.z >= 0 }
		return zlist.size
	end
	def create_verticalfaces(ents,hgrp)
#垂直面の発生
		tr = Geom::Transformation.new ##hgrp.transformation
		hents = hgrp.entities
		outer_loops = hents.find_all{|e| e.kind_of? Sketchup::Face }.map{|fc| fc.outer_loop.vertices.map{|vt| vt.position}  }
		pmesh2 =Geom::PolygonMesh.new( outer_loops.size )
		outer_loops.each{|pts|
			( pts.length ).times{|i|
				pts2 = []
				if pts[i-1].z == 0 and pts[i].z == 0
				elsif pts[i].z == 0
					pts2[2] = pts[i-1]
					pts2[1] = pts[i]
					pts2[0] = pts[i-1].clone;pts2[0].z = 0
				elsif pts[i-1].z == 0
					pts2[2] = pts[i-1]
					pts2[1] = pts[i]
					pts2[0] = pts[i].clone;pts2[0].z = 0
				else
					pts2[3] = pts[i-1]
					pts2[2] = pts[i]
					pts2[1] = pts[i].clone;pts2[1].z = 0
					pts2[0] = pts[i-1].clone;pts2[0].z = 0
				end
				if pts2.size >=3
					pmesh2.add_polygon( pts2 )
				end
			}
		}
		vgrp = ents.add_group
		vgrp.entities.fill_from_mesh( pmesh2 , true , 0 )
		return vgrp
#垂直面の発生終了
	end
	def cleanup(ents,hgrp,eyevec)
		#nrgrphash.each{|key,hgrp|
		#余分なデータの削除
		cleanup_faces(hgrp,eyevec,true)
		#return if @debug == true
		tr = Geom::Transformation.new ##hgrp.transformation
		hents = hgrp.entities
		vgrp = create_verticalfaces(ents,hgrp)

		#if chkint
		if hents.count > 5000
			UI.messagebox "交差する要素が#{hents.count}あり膨大なため交差処理を省略します"
		else
			Sketchup.status_text = "交差の処理中....#{hents.count}x#{hents.count}"
			hents.intersect_with( true , Geom::Transformation.new , hgrp , Geom::Transformation.new , false , hgrp )
			if ( hents.count + vgrp.entities.count ) > 10000
				UI.messagebox "交差する要素が#{hents.count}x#{vgrp.entities.count}あり膨大なため交差処理を省略します"
			else
				Sketchup.status_text = "交差の処理中2....#{hents.count}x#{vgrp.entities.count}"
				vgrp.entities.intersect_with( true , vgrp.transformation , hgrp , tr , false , hgrp )
			end
		end

		#end
		vgrp.erase!#垂直面は不要
		#奥行き方向で見えがからない面の抽出
		
		cleanup_faces(hgrp,eyevec,false)
		
		#エッジの削除：同一平面を境の線
		cnt = 0

		hents.find_all{|e| e.kind_of? Sketchup::Edge }.each{|e|
			cnt += 1
			if ( cnt % 10 ) == 0
				Sketchup.set_status_text "隠れエッジの処理-その2:#{cnt} / #{hents.count}", SB_PROMPT
			end
			fcs = e.faces
			if fcs.size == 2
				nfcs = fcs.find_all{|fc| fc.normal.parallel?( fcs[0].normal ) }
				if fcs.size == nfcs.size
					#同一平面の境界エッジ
					e.hidden =true
					#erlist.push e
				end
			end
		}
	end
	def cleanup_faces(hgrp,eyevec,chkout)
		hents = hgrp.entities
		#hfcs_arr = hents.find_all{|e| e.kind_of? Sketchup::Face and e.normal.perpendicular?( eyevec ) != true }
		vfcs = hents.find_all{|e| e.kind_of? Sketchup::Face }# and e.normal.perpendicular?( eyevec ) }
		hfcs = {}
		hfcs2 = []
		#hfcs_arr.each{|fc| Sketchup.active_model.selection.add fc }
		plane0 = [ [0,0,0] , eyevec ]
		hents.find_all{|e| e.kind_of? Sketchup::Face and e.normal.perpendicular?( eyevec ) != true }.each{|fc|
			#hfcs[fc] = fc.area.to_m.to_m.to_i
			pt0 = [0,0,0]
			fc.vertices.each{|vt|
				(0..2).each{|i| pt0[i] += vt.position[i];}
			}
			#面の頂点の加重平均の点からの0平面への距離を保存してソート
			z = pt0.distance_to_plane(plane0)
			hfcs2.push [ fc.area.to_m.to_m.to_i , z , fc ]
		}
		@hfcs_arr = []
		hfcs2.sort_by{|a,b,c| [ -a , -b ] }.each{|a,b,c|
			@hfcs_arr.push c
		}

		#return if @debug == true
		#hfcs_arr = nil
		#@hfcs_arr = []
		#hfcs.sort{|a,b| b[1]<=>a[1]}.each{|k,v|
		#	@hfcs_arr.push k
		#}
		hfcs2 = nil
		
		p "horizontal faces#{@hfcs_arr.size}"
		erhash = {}
		cnt = 0
		#隠れ面とＺ＝0以下の面の削除
		vfcs.each{|vfc|
			cnt += 1
			if ( cnt % 10 ) == 0
				Sketchup.set_status_text "隠れ面の処理:#{cnt} / #{vfcs.size}", SB_PROMPT
			end
			if get_z0_count(vfc) == 0
				#Z=0未満の面削除
				#hfcs.delete(vfc)
				@hfcs_arr.delete(vfc)
				erhash[vfc]=1
				#erlist.push vfc
			else
				#隠れ面判定
				chk = check_seek_hide_bymesh(vfc,eyevec)#,hfcs_arr)#,erhash)
				if chkout == true and chk == false
					chk = check_seek_hidebyface(vfc,eyevec)#,hfcs_arr)#,erhash)
				end
				if chk == false
					@hfcs_arr.delete(vfc)
					#hfcs.delete(vfc)
					erhash[vfc]=1
					#erlist.push vfc
				end
			end
		}
		p "erase faces#{erhash.size*500}"
		#erlist.each{|fc| Sketchup.active_model.selection.add fc }
		hents.erase_entities erhash.keys
		erhash = nil
		
		#単独線分の見え掛判定と単独垂直線の削除
		#単独線分の削除
		erlist = []
		#hfcs = hents.find_all{|e| e.kind_of? Sketchup::Face and e.normal.perpendicular?( eyevec ) != true }
		cnt = 0
		erlist = hents.find_all{|e| e.kind_of? Sketchup::Edge and e.faces.size == 0}
		if erlist != []
			hents.erase_entities erlist
		end
=begin		
		eds.each{|ed|
			cnt += 1
			if ( cnt % 10 ) == 0
				Sketchup.set_status_text "隠れエッジの処理-その1:#{cnt} / #{eds.size}", SB_PROMPT
			end
			cpt = centerpoint( [ ed.start.position ,ed.end.position ] )
			if check_seek_hide( ed , cpt,eyevec,hfcs ) == false
				erlist.push ed
			elsif ed.line[1].parallel?( Geom::Vector3d.new(0,0,1) )
				erlist.push ed
			end
		}
=end
		#無くてもかまわないエッジの削除
		#p "outerloop"
		#ptss = []
		#hents.find_all{|e| e.kind_of? Sketchup::Face }.each{|fc|
		#	fc.loops.each{|lp|
		#		if not lp.outer?
		#			ptss.push lp.vertices.map{|vt| vt.position }
		#		end
		#	}
		#}
		#ptss.each{|pts|
		#	hents.add_face pts
		#}
		#return
		
		#ここから先の処理は日影のために中空な面などを外形に省略する処理（見えがかりの描画の場合は不要となる）
		#find_facesを使って中空の場所に面を発生する
		erlist = hents.find_all{|e| e.kind_of? Sketchup::Edge }.each{|ed| ed.find_faces }
		
		#平行な２つの面を繋ぐエッジを削除（ほぼ問題ないが、ときどき重なった２面の共有するエッジの場合があると面が消えてしまう）
		erlist = hents.find_all{|e| e.kind_of? Sketchup::Edge and e.faces.size == 2 and e.faces[0].normal.parallel?( e.faces[1].normal ) }
		if erlist != []
			hents.erase_entities erlist
		end
		
		#面の表裏をeyevecに合わせる
		hents.find_all{|e| e.kind_of? Sketchup::Face }.each{|fc|
			if fc.normal.angle_between( eyevec ) < 90.degrees
				fc.reverse!
			end
		}
		#ptss = []
		#erlist = []
		#hents.find_all{|e| e.kind_of? Sketchup::Face }.each{|fc|
		#	ptss.push fc.outer_loop.vertices.map{|vt| vt.position }
		#	erlist.push fc
		#}
		#if erlist != []
		#	hents.erase_entities erlist
		#end
		#ptss.each{|pts|
		#	hents.add_face pts
		#}

		p "erase edges#{erlist.size}"

	end
	def check_seek_hide_bymesh(vfc,eyevec)#,hfcs_arr)#,erhash)
		mesh = vfc.mesh(0)
		#tgrp = hents.add_group
		chk = false
		mesh.polygons.each{|ply|
			pts = ply.map{|i| mesh.point_at(i) }
			cpt = centerpoint( pts )
			if check_seek_hide( vfc,cpt,eyevec ) == true
				chk = true
				break
			end
		}
		return chk
	end
	def check_seek_hidebyface(vfc,eyevec)#,hfcs)#,erhash)
		chk = false
		vfc.vertices.each{|vt|
			if check_seek_hide( vfc,vt.position,eyevec ) == true
				chk = true
				break
			end
		}
		return chk
	end
	def check_seek_hide( ent,cpt,eyevec)#,hfcs_arr)#,erhash={} 
		#見えかかり判定hfcs
		onface = Sketchup::Face::PointInside
		onvertex = Sketchup::Face::PointOnVertex
		onedge = Sketchup::Face::PointOnEdge
		
		line1 = [cpt , eyevec]
		chk = true
		test = true
		
		@hfcs_arr.each{|hfc|
			#if hfc != ent# and erhash[hfc] == nil
				plane1 = hfc.plane
				pt1 = Geom.intersect_line_plane(line1, plane1)
				if pt1
					vec2 = pt1.vector_to(cpt)
					if vec2.valid? and vec2.samedirection?(eyevec)
						#交点が存在し方向が視線と同一の場合
						clfy = hfc.classify_point(pt1)
						if clfy == onface or clfy == onvertex or clfy == onedge
							#交点がその面内にある場合
							chk = false
							break
						end
					end
				end
			#end
		}
		return chk
	end

	def centerpoint( pts )
		s = pts.size
		cpt = [0.0,0.0,0.0]
		pts.each{|pt|
			(0..2).each{|i| cpt[i] += pt[i] }
		}
		(0..2).each{|i| cpt[i] = cpt[i] / s }
		return cpt
	end
	
	def select_jww_exe()
		jwwpath = UI.openpanel("Jw_win.exeを選択してください", "", "*.exe")###
		if jwwpath and jwwpath != ""
			Sketchup.write_default("T2H_Exp2JW","JWWPATH",jwwpath.unpack("H*"))
			return jwwpath
		else
			return ""
		end
	end
	
	def get_jww_path
		dfolder_arr = Sketchup.read_default("T2H_Exp2JW","JWWPATH",[])
		if dfolder_arr == []
			jwwpath = select_jww_exe()
			return jwwpath
		else
			begin
				jwwpath = dfolder_arr.pack("H*")
				if File.exists?( jwwpath )
					return jwwpath
				else
					return ""
				end
			rescue
				return ""
			end
		end
	end
	def export_hikage2jw
		starttime = Time.now.to_f
		model = Sketchup.active_model
		@northpt = [ ]
		jwwpath = get_jww_path
		if jwwpath == ""
			UI.messagebox "有効なJWWへのパスではありませんでした"
			return
		end
		jwwdir = File.dirname( jwwpath )
		
		hgrp = creat_hikagemodel()
		if hgrp == nil or hgrp.valid? == false or hgrp.entities.count == 0
			UI.messagebox "書き出す情報がありませんでした。"
			return
		end
		hents = hgrp.entities

		zmax = model.bounds.max.z
		Sketchup.set_status_text "日影用データをJWWへ書き出し中",SB_PROMPT
		edgs = hents.find_all{|e| e.kind_of? Sketchup::Edge and e.hidden? == false }
		htHash = Hash.new
		#エッジを高さごとに分類
		edgs.each{|ed|
			z1 = ( ed.start.position.z.to_mm.to_f ).round.to_f / 1000
			z2 = ( ed.end.position.z.to_mm.to_f ).round.to_f / 1000
			if z1 != z2
				z = "#{z1}__#{z2}"
			else
				z = "#{z1}"
			end
			
			if htHash == {}
				htHash[ z ] = [ ed ]
			elsif htHash.key?( z )
				list = htHash[ z ]
				list.push ed
			else
				htHash[ z ] = [ ed ]
			end
		}
		names = "0123456789abcdef".split("")
		if htHash.size > 254
			UI.messagebox "必要なレイヤの数が#{htHash.size}個あり254を超えます。そのためJWW上で再現ができない場合があります。"
		end
		i = 0
		cgname = "lg0"
		txtbuff = []
		txtbuff.push cgname
		txtbuff.push "cn0 2.5 2.5 0 5"
		lastg = 0
		lastl = 0
		keys = htHash.keys.sort.reverse
		keys.each{|ht|
		#htHash.each{|ht,eds|
			eds = htHash[ht]
			i = 0 if i > 256
			gnum = ( i / 16 ).to_i
			lnum = i % 16
			lastg = gnum
			lastl = lnum
			#JWWでのレイヤとレイヤグループの指定
			lyname = "ly#{names[ lnum ]}"
			gname = "lg#{names[ gnum ]}"
			if gname != cgname
				cgname = gname
				txtbuff.push "#{cgname}"
			end
			txtbuff.push "#{lyname}"
			#p lyname
			ptlist = []
			zbuff = []
			eds.each{|ed|
				pt1 = [ ed.start.position[0].to_mm.round.to_f , ed.start.position[1].to_mm.round.to_f , ed.start.position[2].to_mm.round.to_f ]
				pt2 = [ ed.end.position[0].to_mm.round.to_f , ed.end.position[1].to_mm.round.to_f , ed.end.position[2].to_mm.round.to_f ]
				if pt1.x == pt2.x and pt1.y == pt2.y
					#２点のxyが等しい場合は無視
				else
					txtbuff.push " #{pt1.x} #{pt1.y} #{pt2.x} #{pt2.y}"
					if pt1.z > 0 or pt2.z > 0
						#Zの値が0より上の場合のみ高さを指定する
						#p " #{pt1.x.to_mm} #{pt1.y.to_mm} #{pt2.x.to_mm} #{pt2.y.to_mm}"
						if ptlist.index( pt1.to_s ) == nil
							ptlist.push pt1.to_s
							vec1 = pt1.vector_to(pt2)
							vec1.length = 375
							zbuff.push "cz #{pt1.x} #{pt1.y} #{vec1.x} #{vec1.y} \"#{ pt1.z / 1000}"
						end
						if ptlist.index( pt2.to_s ) == nil
							ptlist.push pt2.to_s
							vec2 = pt2.vector_to(pt1)
							vec2.length = 375
							zbuff.push "cz #{pt2.x} #{pt2.y} #{vec2.x} #{vec2.y} \"#{ pt2.z / 1000}"
						end
					end
				end
			}

			zbuff.each{|zb|
				txtbuff.push zb
			}
			i += 1
		}
		if @northpt != []
			#JWWでのレイヤとレイヤグループの指定
			if lastl = 15
				lastl = 0
				lastg += 1
			end
			lyname = "ly#{names[ lastl ]}"
			gname = "lg#{names[ lastg ]}"
			txtbuff.push "#{cgname}"
			txtbuff.push "#{lyname}"

			pt1 = [ @northpt[0][0].to_mm.round.to_f , @northpt[0][1].to_mm.round.to_f , @northpt[0][2].to_mm.round.to_f ]
			pt2 = [ @northpt[1][0].to_mm.round.to_f , @northpt[1][1].to_mm.round.to_f , @northpt[1][2].to_mm.round.to_f ]

			txtbuff.push " #{pt1.x} #{pt1.y} #{pt2.x} #{pt2.y}"
			vec2 = pt2.vector_to(pt1)
			#vec2.length = 375
			#ang = vec2.angle_between( Geom::Vector3d.new( 0,-1000,0 ) ).radians
			ang = Math.atan2( -vec2.y,-vec2.x ).radians - 90
			Sketchup.active_model.set_attribute( "T2H_EXPORT2JW_SHADOWS" , "真北" , ang )
			txtbuff.push "ck #{pt2.x} #{pt2.y} #{vec2.x} #{vec2.y} \"#{ang}"
			#vec2.transform!(Geom::Transformation.rotation( [0,0,0], Geom::Vector3d.new(0,0,1), 90.degrees ) )
			#zbuff.push "ck #{pt2.x} #{pt2.y} #{vec2.x} #{vec2.y} \"真北"
		end
		path = File.join( jwwdir , "hikage_solid.txt" )
		txt_file=File.new(path,"w")
		txtbuff.each{|txt|
			txt_file.puts txt
		}
		txt_file.close
		bpath = create_jwwbat( jwwdir )
		#hgrp.erase!
		wastetime = Time.now.to_f - starttime
		
		UI.messagebox "日影データ書き出し完了。\n経過時間#{wastetime}秒\nJWWで外部変形よりSKPhikageSolid.batを選択してください"
		commandline = "start \"max\" \"#{jwwpath}\""# \"#{bpath.gsub(/\//,"\\")}\""
		system(commandline)
		#shell_obj = WIN32OLE.new("WScript.Shell")
		#shell_obj.run jwwpath
		#sleep 1
		#shell_obj.AppActivate("無題")
		#shell_obj.sendKeys("%a")
		#sleep 0.5
		#shell_obj.sendKeys("g")
		#sleep 0.5
	end
	def create_jwwbat(jwwdir)
		path = File.join( jwwdir , 'SKPhikageSolid.bat' )
batbuff='REM HIKAGE import from Sketchup to JWW.by TAK2HATA.
@echo off
REM #jww
REM #cd
REM #e
copy hikage_solid.txt jwc_temp.txt
'
		txt_file=File.new(path,"w")
		txt_file.puts batbuff
		txt_file.close
		return path
	end
	def place_north()
		dfs = Sketchup.active_model.definitions
		ndf = dfs["JWT_NorthMark"]
		if not ndf
			npath = File.join( File.dirname( __FILE__ ) , "JWT_NorthMark.skp" )
			if not File.exists?( npath )
				UI.messagebox "JWT_NorthMark.skpが見つかりませんでした。\nプラグインのt2h_export2jww_shadowフォルダにありますので読み込んでください。"
				return
			end
			ndf = dfs.load( npath )
		end
		Sketchup.active_model.place_component ndf, false
	end

end#class
	unless file_loaded?(__FILE__) 
		file_loaded(__FILE__)
		t2hexpjww = T2H_Exp2JWCLASS.new
		jwwexpmenu = UI.menu("Files").add_submenu("JWWへ日影データを書き出す")
		jwwexpmenu.add_item("JWへデータを書き出す" ) { t2hexpjww.export_hikage2jw }
		jwwexpmenu.add_separator
		jwwexpmenu.add_item("真北マークの配置" ) { t2hexpjww.place_north }
		jwwexpmenu.add_item("真北マークから方位を読み取る" ) { t2hexpjww.read_north }
		jwwexpmenu.add_separator
		jwwexpmenu.add_item("JWWへのファイルパスの指定" ) { t2hexpjww.select_jww_exe }
		jwwexpmenu.add_separator
		jwwexpmenu.add_item("JW用日影モデルの確認" ) { 
			jhdf = t2hexpjww.creat_hikagemodel
			Sketchup.active_model.place_component jhdf, false
			UI.messagebox"JWT_HIKAGE_MODELを作成しました"
		}
		jwwexpmenu.add_item("ライン上の日影時間チャートグラフの描画" ) { Sketchup.active_model.select_tool( T2H_Click_Edge_Tool.new )}
		#jwwexpmenu.add_item("日差し錐線の描画" ) { t2hexpjww.create_hizashilines }
		#jwwexpmenu.add_item("日差し錐線の描画2" ) { t2hexpjww.create_hizashilines2}
	end

end
end
